﻿Imports System.IO
Imports System.Security.Cryptography

Public Class Form1
    'Procédure qui se lance au démarrage du programme
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'Récupère le fichier qui est glissé/déposé sur FileProtector
        Dim arguments As String() = Environment.GetCommandLineArgs()
        'Le fichier déposé est ici arguments(1), arguments(0) étant FileProtector lui-même
        If arguments.Length > 1 Then 'si l'on a deux arguments, on a bien glissé/déposé un fichier
            Try
                Dim fichier As String = arguments(1) 'récupère le nom du fichier glissé/déposé
                'lit les données du fichier glissé/déposé
                Dim donneesFichier As String = System.Text.Encoding.Default.GetString((IO.File.ReadAllBytes(fichier)))
                'demande un mot de passe
                Dim motdepasse As String = InputBox("Mot de passe :", "Choisir un mot de passe")
                If Not motdepasse = vbNullString Then 'si l'on a bien fourni un mot de passe

                    Dim s3des As New Simple3Des(motdepasse) 'prépare le chiffrement
                    Dim chiffre As String = s3des.EncryptData(donneesFichier) 'chiffre les données du fichier
                    If IO.File.Exists(Application.StartupPath & "\copy.exe") Then
                        IO.File.Delete(Application.StartupPath & "\copy.exe") 'supprime le fichier temporaire s'il existe
                    End If
                    'copie FileProtector dans un fichier temporaire car on ne peut éditer un programme en cours d'exécution
                    IO.File.Copy(Application.ExecutablePath, Application.StartupPath & "\copy.exe")
                    'Ouvre le fichier temporaire
                    FileOpen(1, Application.StartupPath & "\copy.exe", OpenMode.Binary, OpenAccess.ReadWrite, OpenShare.Default)
                    Dim contenu As String = Space(LOF(1)) 'prépare "contenu" à recevoir le contenu du fichier temporaire
                    FileGet(1, contenu) 'récupère le contenu du fichier temporaire
                    If contenu.Contains("#separateur#") Then 'si on a le séparateur dans le contenu
                        MsgBox("Un fichier caché existe déjà !") 'c'est qu'un fichier est déjà caché
                        FileClose(1) 'on arrête donc et on supprime le fichier temporaire
                        IO.File.Delete(Application.StartupPath & "\copy.exe")
                        End
                    End If
                    'on place le séparateur à la fin du fichier, et on ajoute également l'extension du fichier glissé/déposé
                    FilePut(1, "#separateur#" & IO.Path.GetExtension(fichier) & "#ext#" & chiffre)
                    FileClose(1) 'on ferme le fichier
                    RenommeEtSupprime("copy.exe") 'le fichier temporaire devient le nouveau FileProtector avec le contenu chiffré
                Else
                    End
                End If
            Catch cryptoex As CryptographicException
                MsgBox("Erreur de mot de passe : " & cryptoex.ToString)
                End
            Catch unauth As UnauthorizedAccessException
                MsgBox("Opération non permise : " & unauth.ToString)
                End
            Catch ex As Exception
                MsgBox("Erreur générique" & ex.ToString)
                End
            End Try
            End 'on termine le programme sans affiche l'interface car on chiffre simplement
        Else 'si l'on a pas deux arguments, c'est qu'on n'a glissé/déposé aucun fichier, on joue un son et affiche le message d'erreur
            Media.SystemSounds.Exclamation.Play()
        End If
    End Sub

    'Transforme le fichier temporaire en fichier FileProtector
    Private Sub RenommeEtSupprime(ByVal nomFichierTemp As String)
        Dim fichierbatch As String = Application.StartupPath & "\batch.bat"
        If IO.File.Exists(fichierbatch) Then
            IO.File.Delete(fichierbatch) 'supprime le fichier batch s'il existe déjà
        End If
        'créer un fichier batch qui pourra supprimer l'ancien FileProtector puis renommer le fichier temporaire en FileProtector
        'avant de s'auto supprimer
        FileOpen(3, fichierbatch, OpenMode.Binary, OpenAccess.ReadWrite, OpenShare.Default)
        FilePut(3, "@echo off" & vbNewLine) 'on affiche 'rien' à l'écran
        FilePut(3, "TIMEOUT /T 2" & vbNewLine) 'on attend que FileProtector soit bien terminé
        FilePut(3, "del " & """" & Application.ExecutablePath & """" & vbNewLine) 'on supprime FileProtector
        'on renomme le fichier temporaire en FileProtector
        FilePut(3, "rename " & """" & Application.StartupPath & "\" & nomFichierTemp & """ " & _
                IO.Path.GetFileName(Application.ExecutablePath) & vbNewLine)
        'on supprime ce propre fichier batch
        FilePut(3, "del " & """" & fichierbatch & """" & vbNewLine)
        FileClose(3)
        Process.Start(Application.StartupPath & "\batch.bat") 'on lance ce fichier batch
    End Sub

    'Lors d'un clic sur le "bouton secret"
    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click
        Try
            'demande le mot de passe
            Dim motdepasse As String = InputBox("Mot de passe de déchiffrement :", "Déchiffrement")
            If Not motdepasse = vbNullString Then 'si on a donné un mot de passe
                If IO.File.Exists(Application.StartupPath & "\copy.exe") Then
                    IO.File.Delete(Application.StartupPath & "\copy.exe") 'supprime le fichier temporaire s'il existe
                End If
                'créer le fichier temporaire contenant une copie de FileProtector avec fichier caché
                IO.File.Copy(Application.ExecutablePath, Application.StartupPath & "\copy.exe")
                'lit ce fichier temporaire
                FileOpen(4, Application.StartupPath & "\copy.exe", OpenMode.Binary, OpenAccess.Read, OpenShare.Shared)
                Dim contenu As String = Space(LOF(4))
                FileGet(4, contenu) 'récupère son contenu
                FileClose(4)

                Dim separateur As String() = Split(contenu, "#separateur#") '...011011101#separateur#.txt#ext#abcdef...
                If separateur.Length <= 1 Then 'si on n'a pas encore caché de fichier, on arrête ici
                    End
                End If
                Dim separateur2 As String() = Split(separateur(1), "#ext#") 'sépare le fichier selon le séparateur "#ext#"
                'supprime le fichier temporaire
                IO.File.Delete(Application.StartupPath & "\copy.exe")

                If IO.File.Exists(Application.StartupPath & "\copy2.exe") Then
                    IO.File.Delete(Application.StartupPath & "\copy2.exe") 'supprime le deuxième fichier temp s'il existe
                End If
                'créer un deuxième fichier temporaire
                FileOpen(5, Application.StartupPath & "\copy2.exe", OpenMode.Binary, OpenAccess.Write, OpenShare.Shared)
                FilePut(5, separateur(0), 1) 'ce deuxième fichier temporaire permet de remettre à 0 FileProtector enlevant le contenu caché
                FileClose(5)

                Dim extension As String = separateur2(0) 'récupère l'extension du fichier caché
                Dim fichieradechiffrer As String = separateur2(1) 'récupère le contenu du fichier caché

                Dim s3des As New Simple3Des(motdepasse) 'prépare le déchiffrement
                Dim res As String = s3des.DecryptData(fichieradechiffrer) 'déchiffre le fichier caché
                FileOpen(2, Application.StartupPath & "\dechiffre" & extension, OpenMode.Binary, OpenAccess.ReadWrite, OpenShare.Default)
                FilePut(2, res) 'affiche le contenu déchiffré dans dechiffre.extension du fichier initial
                FileClose(2)
                RenommeEtSupprime("copy2.exe") 'supprime le fichier temporaire et réinitialise FileProtector
                End
            Else
                End
            End If
        Catch cryptoex As CryptographicException
            MsgBox("Erreur de mot de passe")
            If IO.File.Exists(Application.StartupPath & "\copy2.exe") Then
                IO.File.Delete(Application.StartupPath & "\copy2.exe") 'supprime le deuxième fichier temp s'il existe
            End If
            End
        Catch unauth As UnauthorizedAccessException
            MsgBox("Opération non permise : " & unauth.ToString)
            End
        Catch ex As Exception
            MsgBox("Erreur générique" & ex.ToString)
            End
        End Try
        End

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        End 'clic sur le bouton "Close" du message d'erreur qui ferme l'application
    End Sub

End Class
