﻿Imports System.Security.Cryptography
Public NotInheritable Class Simple3Des
    'récupéré ici : https://docs.microsoft.com/en-us/dotnet/visual-basic/programming-guide/language-features/strings/walkthrough-encrypting-and-decrypting-strings
    'le fichier final prendra plus ou moins de place sur le disque suivant l'algo de chiffrement
    'par exemple pour un chiffrement ROT13 classique, la même taille sera allouée 
    'la vitesse de chiffrement/déchiffrement dépend également de l'algo, à vous d'en tester plusieurs ou de lire des benchmarks :)
    Private TripleDes As New TripleDESCryptoServiceProvider
    Private Function TruncateHash(
    ByVal key As String,
    ByVal length As Integer) As Byte()

        Dim sha1 As New SHA1CryptoServiceProvider

        ' Hash the key.
        Dim keyBytes() As Byte =
            System.Text.Encoding.Unicode.GetBytes(key)
        Dim hash() As Byte = sha1.ComputeHash(keyBytes)

        ' Truncate or pad the hash.
        ReDim Preserve hash(length - 1)
        Return hash
    End Function
    Sub New(ByVal key As String)
        ' Initialize the crypto provider.
        TripleDes.Key = TruncateHash(key, TripleDes.KeySize \ 8)
        TripleDes.IV = TruncateHash("", TripleDes.BlockSize \ 8)
    End Sub
    Public Function EncryptData(
    ByVal plaintext As String) As String

        ' Convert the plaintext string to a byte array.
        Dim plaintextBytes() As Byte =
            System.Text.Encoding.Unicode.GetBytes(plaintext)

        ' Create the stream.
        Dim ms As New System.IO.MemoryStream
        ' Create the encoder to write to the stream.
        Dim encStream As New CryptoStream(ms,
            TripleDes.CreateEncryptor(),
            System.Security.Cryptography.CryptoStreamMode.Write)

        ' Use the crypto stream to write the byte array to the stream.
        encStream.Write(plaintextBytes, 0, plaintextBytes.Length)
        encStream.FlushFinalBlock()

        ' Convert the encrypted stream to a printable string.
        Return Convert.ToBase64String(ms.ToArray)
    End Function

    Public Function DecryptData(
        ByVal encryptedtext As String) As String

        ' Convert the encrypted text string to a byte array.
        Dim encryptedBytes() As Byte = Convert.FromBase64String(encryptedtext)

        ' Create the stream.
        Dim ms As New System.IO.MemoryStream
        ' Create the decoder to write to the stream.
        Dim decStream As New CryptoStream(ms,
            TripleDes.CreateDecryptor(),
            System.Security.Cryptography.CryptoStreamMode.Write)

        ' Use the crypto stream to write the byte array to the stream.
        decStream.Write(encryptedBytes, 0, encryptedBytes.Length)
        decStream.FlushFinalBlock()

        ' Convert the plaintext stream to a string.
        Return System.Text.Encoding.Unicode.GetString(ms.ToArray)
    End Function

    'exemple avec rc4 (chiffre et déchiffre en une fonction)

    'Public Shared Function rc4(ByVal message As String, ByVal password As String) As String
    '    Dim i As Integer = 0
    '    Dim j As Integer = 0
    '    Dim cipher As New System.Text.StringBuilder()
    '    Dim returnCipher As String = String.Empty
    '    Dim sbox As Integer() = New Integer(256) {}
    '    Dim key As Integer() = New Integer(256) {}
    '    Dim intLength As Integer = password.Length
    '    Dim a As Integer = 0
    '    While a <= 255
    '        Dim ctmp As Char = (password.Substring((a Mod intLength), 1).ToCharArray()(0))
    '        key(a) = Microsoft.VisualBasic.Strings.Asc(ctmp)
    '        sbox(a) = a
    '        System.Math.Max(System.Threading.Interlocked.Increment(a), a - 1)
    '    End While
    '    Dim x As Integer = 0
    '    Dim b As Integer = 0
    '    While b <= 255
    '        x = (x + sbox(b) + key(b)) Mod 256
    '        Dim tempSwap As Integer = sbox(b)
    '        sbox(b) = sbox(x)
    '        sbox(x) = tempSwap
    '        System.Math.Max(System.Threading.Interlocked.Increment(b), b - 1)
    '    End While
    '    a = 1
    '    While a <= message.Length
    '        Dim itmp As Integer = 0
    '        i = (i + 1) Mod 256
    '        j = (j + sbox(i)) Mod 256
    '        itmp = sbox(i)
    '        sbox(i) = sbox(j)
    '        sbox(j) = itmp
    '        Dim k As Integer = sbox((sbox(i) + sbox(j)) Mod 256)
    '        Dim ctmp As Char = message.Substring(a - 1, 1).ToCharArray()(0)
    '        itmp = Asc(ctmp)
    '        Dim cipherby As Integer = itmp Xor k
    '        cipher.Append(Chr(cipherby))
    '        System.Math.Max(System.Threading.Interlocked.Increment(a), a - 1)
    '    End While
    '    returnCipher = cipher.ToString
    '    cipher.Length = 0
    '    Return returnCipher
    'End Function
End Class